'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generate = generate;
exports.createNodeGenerator = createNodeGenerator;

var _utils = require('./utils');

var _ast = require('./ast');

var _dts = require('./dts');

function generate(_ref, fileMeta) {
  var moduleId = _ref.moduleId;
  var moduleExports = _ref.moduleExports;
  var moduleImports = _ref.moduleImports;
  var interfaces = _ref.interfaces;
  var root = _ref.root;
  var suppressModulePath = _ref.suppressModulePath;
  var suppressComments = _ref.suppressComments;
  var markUnspecifiedAsOptional = _ref.markUnspecifiedAsOptional;
  var suppressAmbientDeclaration = _ref.suppressAmbientDeclaration;

  var nodes = moduleImports.concat(interfaces, moduleExports).filter(_utils.id);

  var module = (0, _ast.createModuleDeclaration)(suppressModulePath ? root : moduleId, nodes);

  fileMeta.dts = module;
  return module.toString({ suppressComments: suppressComments, markUnspecifiedAsOptional: markUnspecifiedAsOptional, suppressAmbientDeclaration: suppressAmbientDeclaration });
}

function createNodeGenerator(_ref2) {
  var root = _ref2.root;

  return (0, _dts.generateNode)({ root: root });
}